#include "w25qxx.h"
#include "spi.h"

void W25Q_WriteEnable_06()
{
    BEGIN();
    SEND(0x06);
    END();
}

BYTE W25Q_ReadSR1_05()
{
    BYTE dat;
    
    BEGIN();
    SEND(0x05);
    dat = RECV();
    END();

    return dat;
}

void W25Q_WaitBusy(int n)       //Զѯʱ䵥λ: us
{
    while (W25Q_ReadSR1_05() & 0x01);

    if (n);
//    QSPI_POLLING_READ_INSTR_SDATA(0x05, 0x01, 0x00, 12*n);
}

BYTE W25Q_ReadSR2_35()
{
    BYTE dat;
    
    BEGIN();
    SEND(0x35);
    dat = RECV();
    END();

    return dat;
}

BYTE W25Q_ReadSR3_15()
{
    BYTE dat;
    
    BEGIN();
    SEND(0x15);
    dat = RECV();
    END();

    return dat;
}

void W25Q_ReadData_03(DWORD addr, BYTE *pdat, WORD datalen)
{
    BEGIN();
    SEND(0x03);
    SEND((BYTE)(addr >> 16));
    SEND((BYTE)(addr >> 8));
    SEND((BYTE)(addr));
    while (datalen > 0)
    {
        *pdat = RECV();
        
        pdat++;
        datalen--;
    }
    END();
}

void W25Q_FastRead_0B(DWORD addr, BYTE *pdat, WORD datalen)
{
    BEGIN();
    SEND(0x0b);
    SEND((BYTE)(addr >> 16));
    SEND((BYTE)(addr >> 8));
    SEND((BYTE)(addr));
    SEND(0x00);
    while (datalen > 0)
    {
        *pdat = RECV();
        
        pdat++;
        datalen--;
    }
    END();
}

void W25Q_PageProgram_02(DWORD addr, BYTE *pdat, WORD datalen)
{
    WORD cnt;
    
P40 = 0;
P0 = 0x00;
    W25Q_WriteEnable_06();
    while (datalen > 0)
    {
        if (addr & 0xff)
            cnt = 0x100 - (addr & 0xff);
        else
            cnt = 0x100;

        if (datalen < cnt)
            cnt = datalen;
        
        BEGIN();
        SEND(0x02);
        SEND((BYTE)(addr >> 16));
        SEND((BYTE)(addr >> 8));
        SEND((BYTE)(addr));
        
        datalen -= cnt;
        addr += cnt;
        
        while (cnt)
        {
            SEND(*pdat);
            
            pdat++;
            cnt--;
        }
        END();
        
        if (datalen > 0)
        {
            W25Q_WaitBusy(100);
            W25Q_WriteEnable_06();
        }
        P0 = datalen;
    }
    W25Q_WaitBusy(100);
}

void W25Q_Erase4K_20(DWORD addr, BOOL wait)
{
    W25Q_WriteEnable_06();
    
    BEGIN();
    SEND(0x20);
    SEND((BYTE)(addr >> 16));
    SEND((BYTE)(addr >> 8));
    SEND((BYTE)(addr));
    END();

    if (wait)
        W25Q_WaitBusy(100);
}

void W25Q_Erase32K_52(DWORD addr, BOOL wait)
{
    W25Q_WriteEnable_06();
    
    BEGIN();
    SEND(0x52);
    SEND((BYTE)(addr >> 16));
    SEND((BYTE)(addr >> 8));
    SEND((BYTE)(addr));
    END();

    if (wait)
        W25Q_WaitBusy(100);
}

void W25Q_Erase64K_D8(DWORD addr, BOOL wait)
{
    W25Q_WriteEnable_06();
    
    BEGIN();
    SEND(0xd8);
    SEND((BYTE)(addr >> 16));
    SEND((BYTE)(addr >> 8));
    SEND((BYTE)(addr));
    END();

    if (wait)
        W25Q_WaitBusy(100);
}

void W25Q_EraseChip_C7(BOOL wait)
{
    W25Q_WriteEnable_06();
    
    BEGIN();
    SEND(0xc7);
    END();

    if (wait)
        W25Q_WaitBusy(100);
}

DWORD W25Q_ReadJEDECID_9F()
{
    DWORD dat;
    
    dat = 0;
    BEGIN();
    SEND(0x9f);
    dat = RECV();
    dat <<= 8;
    dat |= RECV();
    dat <<= 8;
    dat |= RECV();
    END();

    return dat;
}